      SUBROUTINE DSCAL(N,DA,DX,INCX)                                    
C                                                                       
C     scales a vector by a constant.                                    
C     uses unrolled loops for increment equal to one.                   
C     jack dongarra, linpack, 3/11/78.                                  
C                                                                       
      DOUBLE PRECISION DA,DX(1)                                         
      INTEGER I,INCX,M,MP1,N,NINCX                                      
C                                                                       
      IF(N.LE.0)RETURN                                                  
      IF(INCX.EQ.1)GO TO 20                                             
C                                                                       
C        code for increment not equal to 1                              
C                                                                       
      NINCX = N*INCX                                                    
      DO 10 I = 1,NINCX,INCX                                            
        DX(I) = DA*DX(I)                                                
   10 CONTINUE                                                          
      RETURN                                                            
C                                                                       
C        code for increment equal to 1                                  
C                                                                       
C                                                                       
C        clean-up loop                                                  
C                                                                       
   20 M = MOD(N,5)                                                      
      IF( M .EQ. 0 ) GO TO 40                                           
      DO 30 I = 1,M                                                     
        DX(I) = DA*DX(I)                                                
   30 CONTINUE                                                          
      IF( N .LT. 5 ) RETURN                                             
   40 MP1 = M + 1                                                       
      DO 50 I = MP1,N,5                                                 
        DX(I) = DA*DX(I)                                                
        DX(I + 1) = DA*DX(I + 1)                                        
        DX(I + 2) = DA*DX(I + 2)                                        
        DX(I + 3) = DA*DX(I + 3)                                        
        DX(I + 4) = DA*DX(I + 4)                                        
   50 CONTINUE                                                          
      RETURN                                                            
      END                                                               
