C..   EXAMPLE 3
C..   HARVESTING IN A MULTI-SPECIES ENVIRONMENT
C..
      IMPLICIT REAL*8(A-H,O-Z)
C.. DIMENSION OF PROBLEM
      PARAMETER (N=4,N1=N+1)
C.. DECLARATIONS
      INTEGER LRWORK,LIWORK
      PARAMETER (LRWORK=99999,LIWORK=99999)
      DIMENSION XEQUI(N),X(N1),X0(N),I0(N)
      DIMENSION RWORK(LRWORK),IWORK(LIWORK)
C.. COMMON BLOCK FOR FUNCTION PARAMETERS
      REAL*8 D1,D2,D3,D4,ALPHA1,ALPHA2,BETA,GAMMA,DELTA,
     & EPS1,EPS2,EPS3,THETA1,THETA2,KAPPA,MU,RHO
      COMMON/PARAM/D1,D2,D3,D4,ALPHA1,ALPHA2,BETA,GAMMA,DELTA,
     & EPS1,EPS2,EPS3,THETA1,THETA2,KAPPA,MU,RHO
C.. INITIAL GUESS FOR EQUILIBRIUM
      XEQUI(1)=4D0
      XEQUI(2)=4D0
      XEQUI(3)=1D0
      XEQUI(4)=-5D0
C.. PARAMETER FOR TRANSFORMATION TO FINITE INTERVAL
C        (SET TO ZERO FOR INTERNAL CHOICE)
      R=0.D0
C.. INITIAL CONDITIONS IN ORDER OF IMPORTANCE (CODE SELECTS FIRST NS CONDITIONS)
      I0(1)=1
      X0(I0(1))=1D0
      I0(2)=2
      X0(I0(2))=8D0
C.. REQUIRED TOLERANCE
      TOL=1.D-7
C.. CUT IN EIGENVALUE TREATMENT
      CUT=1.D-12
C.. PRINT PARAMETER
C        (0: NO OUTPUT/1: SMALL OUTPUT/2: LARGE OUTPUT)
      KPRINT=2
C.. OUTPUT UNIT
      OPEN (UNIT=6,FILE='ex3.out')
C.. CALL OF DRIVER
      CALL OPTTRJ(N,XEQUI,X0,I0,R,TOL,CUT,KPRINT,IERR,
     &   RWORK,LRWORK,IWORK,LIWORK)
C.. OUTPUT OF SOLUTION TRAJECTORY
      IF (IERR.NE.0) STOP
      WRITE(6,60900)
60900 FORMAT(/'SOLUTION PROFILE')
      NOUT=100
      WRITE(6,60901) 0.D0,XEQUI(1),XEQUI(2),XEQUI(3),XEQUI(4)
      RATIO=1.D0/NOUT
      DO 900 IOUT=1,NOUT
      S=IOUT*RATIO
      CALL APPSLN(S,X,RWORK,IWORK)
      WRITE(6,60901) S,X(1),X(2),X(3),X(4)
60901 FORMAT(5D18.10)
  900 CONTINUE
      STOP
      END
C
C
      BLOCKDATA
      REAL*8 D1,D2,D3,D4,ALPHA1,ALPHA2,BETA,GAMMA,DELTA,EPS1,EPS2,
     & EPS3,THETA1,THETA2,KAPPA,MU,RHO
      COMMON/PARAM/D1,D2,D3,D4,ALPHA1,ALPHA2,BETA,GAMMA,DELTA,
     & EPS1,EPS2,EPS3,THETA1,THETA2,KAPPA,MU,RHO
      DATA  D1,D2,D3,D4/1D-3,1D0,1D1,1D0/
      DATA  ALPHA1,ALPHA2,BETA,GAMMA/1.73D0,0.75D0,0.05D0,0.75D0/
      DATA  DELTA,EPS1,EPS2,EPS3/0.4D0,0.0026D0,0.0158D0,0.00015D0/
      DATA  THETA1,THETA2,KAPPA,MU,RHO/1D0,1.5D0,0.4D0,1.2D0,0.08D0/
      END
C
C
      SUBROUTINE FEVAL(N,X,F)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION X(N),F(N)
C.. COMMON BLOCK FOR FUNCTION PARAMETERS
      REAL*8 D1,D2,D3,D4,ALPHA1,ALPHA2,BETA,GAMMA,DELTA,EPS1,EPS2,
     & EPS3,THETA1,THETA2,KAPPA,MU,RHO
      COMMON/PARAM/D1,D2,D3,D4,ALPHA1,ALPHA2,BETA,GAMMA,DELTA,
     & EPS1,EPS2,EPS3,THETA1,THETA2,KAPPA,MU,RHO
C .. LOCAL VARIABLES
      REAL*8 K,W,P,Q,A,C,FF,GG,FK,UW
      K=X(1)/D1
      W=X(2)/D2
      P=X(3)/D3
      Q=X(4)/D4
      A=(-P/KAPPA/Q)**(1/(KAPPA-1))
      C=((P-EPS2*Q)/GAMMA/THETA1)**(1/(GAMMA-1))
      FF=ALPHA1*K**ALPHA2
      GG=A**KAPPA
      FK=ALPHA1*ALPHA2*K**(ALPHA2-1)
      UW=-MU*THETA2*W**(MU-1)
      F(1)=D1*(FF-C-A-BETA*K)
      F(2)=D2*(EPS1*FF+EPS2*C+EPS3*K-GG-DELTA*W)
      F(3)=D3*P*(RHO+BETA-FK)-D3*Q*(EPS1*FK+EPS3)
      F(4)=D4*Q*(RHO+DELTA)-UW
      RETURN
      END
C
C
      SUBROUTINE JEVAL(N,L,X,DFDX)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION X(N),DFDX(L,N)
C.. COMMON BLOCK FOR FUNCTION PARAMETERS
      REAL*8 D1,D2,D3,D4,ALPHA1,ALPHA2,BETA,GAMMA,DELTA,EPS1,EPS2,
     & EPS3,THETA1,THETA2,KAPPA,MU,RHO
      COMMON/PARAM/D1,D2,D3,D4,ALPHA1,ALPHA2,BETA,GAMMA,DELTA,
     & EPS1,EPS2,EPS3,THETA1,THETA2,KAPPA,MU,RHO
C .. LOCAL VARIABLES
      REAL*8 A,FK,P,Q,K,W,CP,AP,AQ,GG,FKK,UWW,GP,GQ
      K=X(1)/D1
      W=X(2)/D2
      P=X(3)/D3
      Q=X(4)/D4
      A=(-P/KAPPA/Q)**(1/(KAPPA-1))
      AP=A/P/(KAPPA-1)
      AQ=-A/Q/(KAPPA-1)
      GG=A**KAPPA
      GQ=-GG*KAPPA/Q/(KAPPA-1)
      GP=GG*KAPPA/P/(KAPPA-1)
      FK=ALPHA1*ALPHA2*K**(ALPHA2-1)
      FKK=(ALPHA2-1)*ALPHA1*ALPHA2*K**(ALPHA2-2)
      CP=(P-EPS2*Q)**((2-GAMMA)/(GAMMA-1))*(GAMMA*THETA1)**(1/(1-GAMMA))
     & /(GAMMA-1)
      UWW=-MU*(MU-1)*THETA2*W**(MU-2)
      DFDX(1,1) = (-BETA+FK)
      DFDX(1,2) = 0D0
      DFDX(1,3) = (-CP-AP)*D1/D3
      DFDX(1,4) = (CP*EPS2-AQ)*D1/D4
      DFDX(2,1) = (EPS3+EPS1*FK)*D2/D1
      DFDX(2,2) = (-DELTA)
      DFDX(2,3) = (-GP+EPS2*CP)*D2/D3
      DFDX(2,4) = (-GQ-EPS2**2*CP)*D2/D4
      DFDX(3,1) = FKK*(-P-EPS1*Q)*D3/D1
      DFDX(3,2) = 0D0
      DFDX(3,3) = (BETA+RHO-FK)
      DFDX(3,4) = (-EPS3-EPS1*FK)*D3/D4
      DFDX(4,1) = 0D0
      DFDX(4,2) = (-UWW)*D4/D2
      DFDX(4,3) = 0D0
      DFDX(4,4) = (RHO+DELTA)
      RETURN
      END
